/*
 * connecting_screen.hpp
 *
 * Copyright (c) Stephen Thompson, 2006.
 * Licenced for non-commercial use only. See LICENCE.txt for details.
 *
 * Connecting Screen
 * --- Sets up network connection, and displays progress while doing so
 * --- Continues to MenuScreen
 *
 */

#ifndef CONNECTING_SCREEN_HPP
#define CONNECTING_SCREEN_HPP

#include "app/app2d.hpp"
#include "knights_game.hpp"

#include "boost/shared_ptr.hpp"
using namespace boost;

#include <vector>
using namespace std;

class EnetStream;
class WceSerialStream;

void SetupConnectingScreen(const UsefulStuff &u);
void StopConnectingScreen(const UsefulStuff &u);

class ConnectingScreen : public AppObserver {
public:
	explicit ConnectingScreen(const UsefulStuff &u);

	virtual void render();
	virtual void update();

private:
	UsefulStuff us;
	
#ifdef _WIN32_WCE
	shared_ptr<WceSerialStream> wce_str;
#else
	vector<shared_ptr<EnetStream> > clients;
#endif

};
#endif
