/*
 * event_manager.hpp
 *
 * Copyright (c) Stephen Thompson, 2006.
 * Licenced for non-commercial use only. See LICENCE.txt for details.
 *
 * Processes "script events". Usually called via Mediator.
 *
 */

#ifndef EVENT_MANAGER_HPP
#define EVENT_MANAGER_HPP

#include "map_support.hpp"

class Creature;
class Tile;

class EventManager {
public:
	static void onAddCreature(Creature &);                        // on_walk_over
	static void onRmCreature(Creature &);                          // on_withdraw 
	static void postRepositionCreature(Creature &);                 // on_walk_over
	static void onChangeEntityMotion(Creature &);                        // on_approach, on_withdraw
	static void onAddTile(DungeonMap &, const MapCoord &, Tile &);  // on_walk_over
	static void onRmTile(DungeonMap &, const MapCoord &, Tile &);   // on_withdraw
private:
	static void walkOverEvent(Creature &);
	static void withdrawEvent(Creature &);
};

#endif
