/*
 * knights_game.hpp
 *
 * Copyright (c) Stephen Thompson, 2006.
 * Licenced for non-commercial use only. See LICENCE.txt for details.
 *
 * Top level routine. Called by main().
 * 
 */

#ifndef KNIGHTS_GAME_HPP
#define KNIGHTS_GAME_HPP

#include "boost/shared_ptr.hpp"
using namespace boost;

#include <iosfwd>
#include <string>
using namespace std;

class App2D;
class ClientConfig;
class Controller;
class Display;
class ServerConfig;

// RunKnights

void RunKnights(const string &resource_dir);


// struct UsefulStuff contains a few variables that get passed about between the different
// screens.

struct UsefulStuff {
	App2D *app2d;
	Display *display;
	Controller *left_controller, *right_controller;
	bool server; // true if server or local; false if client
	shared_ptr<iostream> remote;  // NULL if local
	shared_ptr<ServerConfig> server_config;  // only one of server_config or
	shared_ptr<ClientConfig> client_config;  // client_config will be non-NULL
};

#endif
