/*
 * menu.cpp
 *
 * Copyright (c) Stephen Thompson, 2006.
 * Licenced for non-commercial use only. See LICENCE.txt for details.
 *
 */

#include "misc.hpp"

#include "menu.hpp"
#include "menu_constraint.hpp"
#include "menu_selections.hpp"

bool MenuValue::applyConstraints(MenuSelections &msel) const
{
	bool result = false;
	for (vector<shared_ptr<MenuConstraint> >::const_iterator it = constraints.begin();
	it != constraints.end(); ++it) {
		if ((*it)->apply(msel)) result = true;
	}
	return result;
}

