/*
 * my_exceptions.hpp
 *
 * Copyright (c) Stephen Thompson, 2006.
 * Licenced for non-commercial use only. See LICENCE.txt for details.
 *
 * An attempt to standardize some of the exceptions used in the game
 *
 */

#ifndef MY_EXCEPTIONS_HPP
#define MY_EXCEPTIONS_HPP

#include "exception_base.hpp"

#include <string>
using namespace std;

// error during game initialization (eg: sdl font could not be loaded)
class InitError : public ExceptionBase {
public:
	InitError(const string &s) : ExceptionBase(s) { }
};

// failed to load graphic
class GraphicLoadFailed : public ExceptionBase {
public:
	GraphicLoadFailed(const string &s) : ExceptionBase(s) { }
};

// something unexpected happened (throwing this indicates a bug or not-yet-implemented
// feature)

class UnexpectedError : public ExceptionBase {
public:
	UnexpectedError(const string &s) : ExceptionBase(s) { }
};


#endif
