/*
 * title_screen.hpp
 *
 * Copyright (c) Stephen Thompson, 2006.
 * Licenced for non-commercial use only. See LICENCE.txt for details.
 *
 * Title Screen
 * --- Displays credits
 * --- Reads whether we want server, client or local game
 * Sets UsefulStuff::server
 * Continues to either ConnectingScreen (for server or client games) or
 * LoadingScreen (for local games).
 *
 */

#ifndef TITLE_SCREEN_HPP
#define TITLE_SCREEN_HPP

#include "app/app2d.hpp"
#include "knights_game.hpp"

void SetupTitleScreen(const UsefulStuff &u);
void StopTitleScreen(const UsefulStuff &u);

class TitleScreen : public AppObserver {
public:
	explicit TitleScreen(const UsefulStuff &u) : us(u) { }
	virtual void render();
	virtual void mouseDown(int x, int y, bool rmb);
private:
	void xcentre(int y, const char *str);
	UsefulStuff us;
};

#endif
